package memory

import (
	"context"

	"go.opentelemetry.io/otel/attribute"
	"go.opentelemetry.io/otel/codes"
)

func (r *MemoryRecorder) Count(ctx context.Context) int {
	_, span := r.tracer.Start(ctx, "countWeatherRecorder")
	defer span.End()

	count := r.count()

	span.SetAttributes(attribute.Int("count", count))
	span.SetStatus(codes.Ok, "")

	return count
}

func (r *MemoryRecorder) count() int {
	return len(r.updates)
}
