package noop

import (
	"context"

	pb "gitea.libretechconsulting.com/rmcguire/ambient-local-exporter/api/v1alpha1/weather"
	"gitea.libretechconsulting.com/rmcguire/ambient-local-exporter/pkg/weather"
	"gitea.libretechconsulting.com/rmcguire/ambient-local-exporter/pkg/weather/recorder/recorders"
)

type NoopRecorder struct{}

func (n *NoopRecorder) Init(context.Context, *recorders.RecorderOpts) {}

func (n *NoopRecorder) Set(context.Context, *weather.WeatherUpdate) error { return nil }

func (n *NoopRecorder) Get(context.Context, *pb.GetWeatherRequest) ([]*weather.WeatherUpdate, error) {
	return nil, nil
}

func (n *NoopRecorder) Count(context.Context) int { return 0 }

func (n *NoopRecorder) Ping(context.Context) error { return nil }

func (r *NoopRecorder) Name() string { return "no-op recorder" }
