package recorders

import (
	"context"

	pb "gitea.libretechconsulting.com/rmcguire/ambient-local-exporter/api/v1alpha1/weather"
	"gitea.libretechconsulting.com/rmcguire/ambient-local-exporter/pkg/ambient/config"
	"gitea.libretechconsulting.com/rmcguire/ambient-local-exporter/pkg/weather"
)

type RecorderOpts struct {
	RetainLast int
	BaseCtx    context.Context
	AppConfig  *config.AmbientLocalExporterConfig
}

type Recorder interface {
	Init(context.Context, *RecorderOpts)
	Set(context.Context, *weather.WeatherUpdate) error
	Get(context.Context, *pb.GetWeatherRequest) ([]*weather.WeatherUpdate, error)
	Count(context.Context) int // Best Effort
	Ping(context.Context) error
	Name() string
}
